LogTo("step3.log");

checkD := function(gr, c)
  local sg, x, y;
  x := Representative(c);
  for y in c do
    if not (x*y)^2 = (y*x)^2 then 
      sg := Subgroup(gr, [x,y]);
      if IsConjugate(sg, x, y) = false then
        return [x,y];
      fi;
    fi;
  od;
  return fail;
end;

ct := CharacterTable("B");

### This is the list of maximal subgroups of B
### It was taken from the new version of ctbllib
maxes := [ "2.2E6(2).2", "2^(1+22).Co2", "Fi23", "2^(9+16).S8(2)", "Th", "(2^2xF4(2)):2", "2^(2+10+20).(M22.2xS3)", "[2^30].L5(2)", "S3xFi22.2", "[2^35].(S5xL3(2))", "HN.2", "O8+(3).S4", 
           "3^(1+8).2^(1+6).U4(2).2", "(3^2:D8xU4(3).2^2).2", "5:4xHS.2", "S4x2F4(2)'.2", "3^2.3^3.3^6.(S4x2S4)", "A5.2xM22.2", "(S6xL3(4).2).2", "5^3.psl(3,5)", "5^(1+4).2^(1+4).A5.4", 
           "(S6xS6).4", "5^2:4S4xS5", "L2(49).2_3", "L2(31)", "M11", "L3(3)", "L2(17).2", "L2(11).2", "47:23" ];

l := [];

for m in maxes do
  if 47 in OrdersClassRepresentatives(CharacterTable(m)) then
    Add(l, m);
  fi;
od;

Print("Maximal subgroups of B with elements of order 47:\n");
Display(l);

# The maximal subgroup is isomorphic to the group with Id [1081, 1]
# It is the only non-abelian group of order 1081
gr := SmallGroup(47*23, 1);
cc := ConjugacyClasses(gr);

for c in cc do
  if Order(Representative(c)) = 47 then
    rs := checkD(gr, c);
    if rs = fail then
      Print("The class if not of type D\n");
    else
      Print(rs, "\n");
    fi;
  fi;
od;

