LoadPackage("atlasrep");

checkD_random := function(gr, x, n)
  local sg, i, t, y;
  Print("Trying with n=", n, "\n");
  for i in [1..n] do
  	t := Random(gr);
    y := t*x*Inverse(t);
    if not (x*y)^2 = (y*x)^2 then 
      sg := Subgroup(gr, [x,y]);
      if IsConjugate(sg, x, y) = false then
        return [x,y];
      fi;
    fi;
  od;
  return fail;
end;

checkD := function(gr, c)
  local sg, x, y;
  x := Representative(c);
  for y in c do
    if not (x*y)^2 = (y*x)^2 then 
      sg := Subgroup(gr, [x,y]);
      if IsConjugate(sg, x, y) = false then
        return [x,y];
      fi;
    fi;
  od;
  return fail;
end;

x := [];
g := [];

maxes := [1,8,9];
group := "HS";
class := 11;
LogTo(Concatenation(String(class), "AB.log"));

for max in maxes do
  gr := Group(AtlasGenerators(group, 1, max).generators);
  cc := ConjugacyClasses(gr);

  Print("Group ", group, ", maximal: ", max, "\n");

  for c in cc do
    g := Representative(c);

    if Order(g) <> class then
      continue;
    fi;
  
    Print("Representative of order ", Order(g), ", ");
    rs := checkD(gr, c);
    if rs = fail then
      Print("the class if not of type D\n");
    fi;
  od;
od;  


